// ##### ENDFILE "VirtualSystemDescriptionFormWrap.h"


// ##### BEGINFILE "CloudNetworkGatewayInfoWrap.h"
/** @file
 * VirtualBox API class wrapper header for ICloudNetworkGatewayInfo.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/*
 * Copyright (C) 2010-2020 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef CloudNetworkGatewayInfoWrap_H_
#define CloudNetworkGatewayInfoWrap_H_
#ifndef RT_WITHOUT_PRAGMA_ONCE
# pragma once
#endif

#include "VirtualBoxBase.h"
#include "Wrapper.h"

class ATL_NO_VTABLE CloudNetworkGatewayInfoWrap
    : public VirtualBoxBase
    , VBOX_SCRIPTABLE_IMPL(ICloudNetworkGatewayInfo)
{
    Q_OBJECT

public:
    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT(CloudNetworkGatewayInfoWrap, ICloudNetworkGatewayInfo)
    DECLARE_NOT_AGGREGATABLE(CloudNetworkGatewayInfoWrap)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(CloudNetworkGatewayInfoWrap)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
        COM_INTERFACE_ENTRY(ICloudNetworkGatewayInfo)
        COM_INTERFACE_ENTRY2(IDispatch, ICloudNetworkGatewayInfo)
        VBOX_TWEAK_INTERFACE_ENTRY(ICloudNetworkGatewayInfo)
    END_COM_MAP()

    DECLARE_EMPTY_CTOR_DTOR(CloudNetworkGatewayInfoWrap)

    /** @name Public ICloudNetworkGatewayInfo properties
     * @{ */
    STDMETHOD(COMGETTER(PublicIP))(BSTR *aPublicIP);
    STDMETHOD(COMGETTER(SecondaryPublicIP))(BSTR *aSecondaryPublicIP);
    STDMETHOD(COMGETTER(MacAddress))(BSTR *aMacAddress);
    STDMETHOD(COMGETTER(InstanceId))(BSTR *aInstanceId);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute1ICloudNetworkGatewayInfo))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute2ICloudNetworkGatewayInfo))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute3ICloudNetworkGatewayInfo))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute4ICloudNetworkGatewayInfo))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute5ICloudNetworkGatewayInfo))(ULONG *aReserved);
    /** @} */

    /** @name Public ICloudNetworkGatewayInfo methods
     * @{ */
    /** @} */

private:
    /** @name Wrapped ICloudNetworkGatewayInfo properties
     * @{ */
    virtual HRESULT getPublicIP(com::Utf8Str &aPublicIP) = 0;
    virtual HRESULT getSecondaryPublicIP(com::Utf8Str &aSecondaryPublicIP) = 0;
    virtual HRESULT getMacAddress(com::Utf8Str &aMacAddress) = 0;
    virtual HRESULT getInstanceId(com::Utf8Str &aInstanceId) = 0;
    /** @} */

    /** @name Wrapped ICloudNetworkGatewayInfo methods
     * @{ */
    /** @} */

private:
    DECLARE_CLS_COPY_CTOR_ASSIGN_NOOP(CloudNetworkGatewayInfoWrap); /* Shuts up MSC warning C4625. */

};

#endif // !CloudNetworkGatewayInfoWrap_H_

